/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005-2008. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.apt.web.client.internal.PlanExtensionRegistry"); //$NON-NLS-1$

dojo.require("net.jazz.ajax.core.runtime.RegistryFactory"); //$NON-NLS-1$

(function() { // module container

var RegistryFactory 	= net.jazz.ajax.core.runtime.RegistryFactory;


com.ibm.team.apt.web.client.internal.PlanExtensionRegistry= {
	
	// ---- API ------------------------------------------------------------------------------------------------------------	
	
	getContributedTabs: function() {
		if (this._contributedTabs == null) {
			this._loadContributedTabs();
		}
		return this._contributedTabs;
	},

	// ---- implementation -------------------------------------------------------------------------------------------------

	_contributedTabs: null,

	_loadContributedTabs: function() {
		var extensionPoint= RegistryFactory.getRegistry().getExtensionPoint("com.ibm.team.apt.web.iterationPlanTab"); //$NON-NLS-1$

		var contributedTabs= [];
		dojo.forEach(extensionPoint.getExtensions(), function(extension) {
			dojo.forEach(extension.getConfigurationElements(), function(configElement) {
				contributedTabs.push({
					id: configElement.getAttribute("id"), //$NON-NLS-1$
					name: configElement.getAttribute("name"), //$NON-NLS-1$
					widgetId: configElement.getAttribute("widgetId") //$NON-NLS-1$
				});
			});
		});
		
		this._contributedTabs= contributedTabs;
	},

	__sentinel: null // terminates this class definition
	
};

})();