/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005-2008. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("com.ibm.team.process.web.ui.internal.admin.projects.TeamAreaEditor"); //$NON-NLS-1$

dojo.require("dijit._Widget"); //$NON-NLS-1$
dojo.require("dijit._Templated"); //$NON-NLS-1$
dojo.require("dojox.data.dom"); //$NON-NLS-1$
dojo.require("dojo.cookie"); //$NON-NLS-1$
dojo.require("dojo.i18n"); //$NON-NLS-1$

dojo.require("net.jazz.ajax.ui.PlatformUI"); //$NON-NLS-1$
dojo.require("net.jazz.ajax.ui.internal.Dialog"); //$NON-NLS-1$

dojo.require("com.ibm.team.repository.web.client.internal.AdminClient"); //$NON-NLS-1$
dojo.require("com.ibm.team.process.web.client.internal.ProcessClient"); //$NON-NLS-1$
dojo.require("com.ibm.team.repository.web.client.session.Session"); //$NON-NLS-1$
dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler"); //$NON-NLS-1$
dojo.require("com.ibm.team.process.web.ui.internal.admin.projects.ProcessRoleDialog"); //$NON-NLS-1$
dojo.require("com.ibm.team.process.web.ui.internal.admin.projects.TeamParentSelector"); //$NON-NLS-1$
dojo.require("com.ibm.team.process.web.ui.internal.admin.projects.TeamInvitationDialog"); //$NON-NLS-1$
dojo.require("com.ibm.team.process.web.ui.internal.admin.projects.InvitationCustomizationDialog"); //$NON-NLS-1$
dojo.require("com.ibm.team.process.web.ui.internal.TeamContributorSelectionDialog"); //$NON-NLS-1$

dojo.requireLocalization("com.ibm.team.process.web.ui.internal.admin.projects", "Messages"); //$NON-NLS-1$ //$NON-NLS-2$

var PlatformUI = net.jazz.ajax.ui.PlatformUI;
var AdminClient = com.ibm.team.repository.web.client.internal.AdminClient;
var ProcessClient = com.ibm.team.process.web.client.internal.ProcessClient;
var ServiceResponseHandler = com.ibm.team.repository.web.transport.ServiceResponseHandler;
var getAuthenticatedContributor = com.ibm.team.repository.web.client.session.getAuthenticatedContributor;
var MANAGER = "com.ibm.team.process.manageProjectAreas"; //$NON-NLS-1$
var ARCHIVED_MANAGER = "com.ibm.team.process.manageArchivedProjectAreas"; //$NON-NLS-1$
var PROJECT_AREA_EDITOR = "com.ibm.team.process.editProjectArea"; //$NON-NLS-1$
var TEAM_AREA_EDITOR = "com.ibm.team.process.editTeamArea"; //$NON-NLS-1$
var USER_EDITOR = "com.ibm.team.repository.editUser"; //$NON-NLS-1$
var ARCHIVED_USER_EDITOR = "com.ibm.team.repository.editArchivedUser"; //$NON-NLS-1$
var MSG_COOKIE_NAME = "com.ibm.team.process.editTeamArea#saveMsg"; //$NON-NLS-1$
var TEAM_INVITATION_COOKIE_NAME= "com.ibm.team.process.web.ui.internal.admin.projects.ProjectAreaEditor#teamInvite"; //$NON-NLS-1$
var KEY_RETURN = 13;
var KEY_ENTER = 14;
var DEFAULT_DISPLAY_MAX = 5;
var SHOW_TEXT_LENGTH = 1024;
var MODE_PREVIEW = "Preview"; //$NON-NLS-1$
var MODE_EDIT = "Edit"; //$NON-NLS-1$

var ON_CLICK = "onclick"; //$NON-NLS-1$
var ON_KEYUP = "onkeyup"; //$NON-NLS-1$
var ON_CHANGE = "onchange"; //$NON-NLS-1$
var ON_MOUSEOVER = "onmouseover"; //$NON-NLS-1$
var ON_MOUSEOUT = "onmouseout"; //$NON-NLS-1$
var ON_BLUR = "onblur"; //$NON-NLS-1$
var ON_ADD = "onAdd"; //$NON-NLS-1$

var INLINE = "inline"; //$NON-NLS-1$
var NONE = "none"; //$NON-NLS-1$
var BLOCK = "block"; //$NON-NLS-1$
var DIV = "div"; //$NON-NLS-1$
var EMPTY = ""; //$NON-NLS-1$
var BR = "br"; //$NON-NLS-1$

dojo.declare("com.ibm.team.process.web.ui.internal.admin.projects.TeamAreaEditor", [dijit._Widget, dijit._Templated], { //$NON-NLS-1$
	
	templatePath: dojo.moduleUrl("com.ibm.team.process.web", "ui/internal/admin/projects/templates/TeamAreaEditor.html"), //$NON-NLS-1$ //$NON-NLS-2$
	
	constructor: function(args){
		this.messages = dojo.i18n.getLocalization("com.ibm.team.process.web.ui.internal.admin.projects", "Messages"); //$NON-NLS-1$ //$NON-NLS-2$
		this.isNew = args.itemId === "new"; //$NON-NLS-1$
		if (!this.isNew) {
			this.itemId = args.itemId;
		}
		this.parentItemId = args.parentItemId;
		this.parentName = args.parentName;
		this.parentType = args.parentType;
		this._teamAreaIconSrc = dojo.moduleUrl("com.ibm.team.process.web", "ui/internal/admin/projects/images/teamAreaIcon.png"); //$NON-NLS-1$ //$NON-NLS-2$
	},
	
	postCreate: function () {
		this.showingAllMembers = false;
		this.showingAllAdmins = false;
		this.connectHandles = [];
		this.inputFields = [
			this.name,
			this.summary,
			this.description
		];
		this.connect(this.name, "onkeypress", function (e) { //$NON-NLS-1$
			if (e.keyCode === KEY_RETURN || e.keyCode === KEY_ENTER) {
				dojo.stopEvent(e);
				this.togglePrimaryField(MODE_PREVIEW);
			}
		});
		this.summary.viewElement = this.summaryView;
		this.summary.viewAllElement = this.summaryViewAll;
		this.summary.showAllLink = this.showAllSummaryLink;
		this.summary.showLessLink = this.showLessSummaryLink;
		this.summary.showingAll = false;
		this.description.viewElement = this.descriptionView;
		this.description.viewAllElement = this.descriptionViewAll;
		this.description.showAllLink = this.showAllDescriptionLink;
		this.description.showLessLink = this.showLessDescriptionLink;
		this.description.showingAll = false;
		this.editViewFields = [
			this.summary,
			this.description
		];
		this.connect(this.editViewTable,ON_CLICK, function () {
			this.toggleViewEditMode(MODE_EDIT);
		});
		for (var i=0; i < this.inputFields.length; i++) {
			this.connect(this.inputFields[i],ON_KEYUP, "handleChange"); //$NON-NLS-1$
			this.connect(this.inputFields[i],ON_CHANGE, "handleChange"); //$NON-NLS-1$
		}
		this.connect(this.memberAddButton,ON_CLICK, function (e) {
			dojo.stopEvent(e);
			if (this.allMembers == null) {
				this.allMembers = new Array();
			}
			this.addUserDialog(this.allMembers, "addNewMembers"); //$NON-NLS-1$
		});
		this.connect(this.adminAddButton,ON_CLICK, function (e) {
			dojo.stopEvent(e);
			if (this.allAdmins == null) {
				this.allAdmins = new Array();
			}
			this.addUserDialog(this.allAdmins, "addNewAdmins"); //$NON-NLS-1$
		});
		this.connect(this.saveButton,ON_CLICK, "handleSave"); //$NON-NLS-1$
		this.connect(this.name,ON_CHANGE, function () {
			if (this.hierarchyNameDisplay != null) {
				dojox.data.dom.removeChildren(this.hierarchyNameDisplay);
				if (this.name.value == EMPTY) {
					this.hierarchyNameDisplay.appendChild(document.createTextNode(this.messages.TeamAreaEditor_1));
				}
				else {
					this.hierarchyNameDisplay.appendChild(document.createTextNode(this.name.value));
				}
			}
		});
		this.connect(this.toggleDescLink,ON_CLICK, function (e) {
			dojo.stopEvent(e);
			this.toggleViewEditMode(e.target.innerHTML);
		});
		
		this.connect(this.previewName,ON_MOUSEOVER, function (e) {
			e.target.style.backgroundColor = "#FFFFCC"; //$NON-NLS-1$
		});
		this.connect(this.previewName,ON_MOUSEOUT, function (e) {
			e.target.style.backgroundColor = EMPTY;
		});
		this.connect(this.previewName,ON_CLICK, function (e) {
			this.togglePrimaryField(MODE_EDIT);
		});
		this.connect(this.name, "ON_BLUR", function (e) { //$NON-NLS-1$
			this.togglePrimaryField(MODE_PREVIEW);
		});
		
		if (!this.isNew) {
			this.createChildButton.style.display = EMPTY;
			this.connect(this.createChildButton,ON_CLICK, function (e) {
				dojo.stopEvent(e);
				if (!this._handleNavigate()) {
					document.location.href = "#action=" + TEAM_AREA_EDITOR + "&itemId=new&parentItemId=" + this.itemId + "&parentType=TEAM"; //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
				}
			});
		}
		this.connect(this.showAllSummaryLink, ON_CLICK, function(e) {
			dojo.stopEvent(e);
			this.summary.showingAll = true;
			this.summary.viewAllElement.style.display = INLINE;
			this.summary.showAllLink.style.display = NONE;
			this.summary.showLessLink.style.display = BLOCK;
		});
		this.connect(this.showLessSummaryLink, ON_CLICK, function(e) {
			dojo.stopEvent(e);
			this.summary.showingAll = false;
			this.summary.viewAllElement.style.display = NONE;
			this.summary.showAllLink.style.display = BLOCK;
			this.summary.showLessLink.style.display = NONE;
		});
		this.connect(this.showAllDescriptionLink, ON_CLICK, function(e) {
			dojo.stopEvent(e);
			this.description.showingAll = true;
			this.description.viewAllElement.style.display = INLINE;
			this.description.showAllLink.style.display = NONE;
			this.description.showLessLink.style.display = BLOCK;
		});
		this.connect(this.showLessDescriptionLink, ON_CLICK, function(e) {
			dojo.stopEvent(e);
			this.description.showingAll = false;
			this.description.viewAllElement.style.display = NONE;
			this.description.showAllLink.style.display = BLOCK;
			this.description.showLessLink.style.display = NONE;
		});
		this.connect(this.showAllMembersLink, ON_CLICK, function(e) {
			dojo.stopEvent(e);
			this.showingAllMembers = true;
			this.showAllMembersLink.style.display = NONE;
			this.showFewerMembersLink.style.display = BLOCK;
			for (var i=0; i < this.memberArea.rows.length; i++) {
				this.memberArea.rows[i].style.display = EMPTY;
			}
		});
		this.connect(this.showFewerMembersLink, ON_CLICK, function(e) {
			dojo.stopEvent(e);
			this.showingAllMembers = false;
			this.showAllMembersLink.style.display = BLOCK;
			this.showFewerMembersLink.style.display = NONE;
			for (var i=DEFAULT_DISPLAY_MAX; i < this.memberArea.rows.length; i++) {
				this.memberArea.rows[i].style.display = NONE;
			}
		});
		this.connect(this.showAllAdminsLink, ON_CLICK, function(e) {
			dojo.stopEvent(e);
			this.showingAllAdmins = true;
			this.showAllAdminsLink.style.display = NONE;
			this.showFewerAdminsLink.style.display = BLOCK;
			for (var i=0; i < this.adminArea.rows.length; i++) {
				this.adminArea.rows[i].style.display = EMPTY;
			}
		});
		this.connect(this.showFewerAdminsLink, ON_CLICK, function(e) {
			dojo.stopEvent(e);
			this.showingAllAdmins = false;
			this.showAllAdminsLink.style.display = BLOCK;
			this.showFewerAdminsLink.style.display = NONE;
			for (var i=DEFAULT_DISPLAY_MAX; i < this.adminArea.rows.length; i++) {
				this.adminArea.rows[i].style.display = NONE;
			}
		});
		this.refresh();
	},
	
	addUserDialog: function (filterUsers, callbackFunction) {
		var userFilter = new Array();
		for (var i=0; i < filterUsers.length; i++) {
			userFilter.push({'itemId': filterUsers[i].itemId}); //$NON-NLS-1$
		}
		var userPicker = new com.ibm.team.process.web.ui.internal.TeamContributorSelectionDialog({'disableUsers': userFilter}); //$NON-NLS-1$
		this.connect(userPicker,ON_ADD,callbackFunction);
	},
	
	refresh: function () {
		if (!this.navigateAwayHandle) {
			this.navigateAwayHandle = PlatformUI.getWorkbench().registerBodyClickHandler(dojo.hitch(this, this._handleNavigate), /*priority*/ 10000);
			this.onBeforeUnloadHandle = PlatformUI.getWorkbench().registerOnBeforeUnloadHandler(dojo.hitch(this, this.navigateAwayEvent), /*priority*/ 10000);
		}
		this.clearState();
		this.selectedMembers = new Object();
		this.selectedAdmins = new Object();
		this.pendingMemberChanges = new Object();
		this.pendingAdminChanges = new Object();
		
		dojox.data.dom.removeChildren(this.processHierarchy);
		this.processHierarchy.appendChild(document.createTextNode(this.messages.TeamAreaEditor_2));
		dojox.data.dom.removeChildren(this.developmentLineDiv);
		this.developmentLineDiv.appendChild(document.createTextNode(this.messages.TeamAreaEditor_3));
		
		if (this.isNew) {
			this.toggleViewEditMode(MODE_EDIT);
			this.name.value = this.messages.TeamAreaEditor_4;
			this.togglePrimaryField(MODE_EDIT);
			this.populateMembers(new Array());
			this.populateAdmins(new Array());
			this.populateDevelopmentLineSelector();
			
			if (this.parentType != null && this.parentItemId != null) {
				var srh = new ServiceResponseHandler(this, "populateProcessHierarchy", "ignoreError"); //$NON-NLS-1$ //$NON-NLS-2$
				if (this.parentType == "TEAM") { //$NON-NLS-1$
					ProcessClient.getHierarchyForTeamArea({uuid: this.parentItemId}, srh);
				}
				else if (this.parentType == "PROJECT") { //$NON-NLS-1$
					ProcessClient.getProjectHierarchy({uuid: this.parentItemId}, srh);
				}
			}
			setTimeout(dojo.hitch(this.name,"select"), 250); //$NON-NLS-1$
		}
		else {
			dojox.data.dom.removeChildren(this.memberArea);
			dojox.data.dom.removeChildren(this.adminArea);
			var srh = new ServiceResponseHandler(this, "populateTeamAreaData", "handleTeamAreaFetchError"); //$NON-NLS-1$ //$NON-NLS-2$
			ProcessClient.getTeamAreaByUUID({uuid: this.itemId}, srh);
		}
		this.checkForSuccessMsg();
	},
	
	_handleNavigate: function(urlObj) {
		if (this.changesPending()) {
			if (confirm(this.messages.TeamAreaEditor_5)) {
				PlatformUI.getWorkbench().unregisterBodyClickHandler(this.navigateAwayHandle);
				this.navigateAwayHandle = null;
				PlatformUI.getWorkbench().unregisterOnBeforeUnloadHandler(this.onBeforeUnloadHandle);
				this.onBeforeUnloadHandle = null;
				return false;
			}
			else {
				return true;
			}
		}
		return false;
	},
	
	navigateAwayEvent: function() {
		return this.changesPending() ? this.messages.TeamAreaEditor_6 : false;
	},
	
	checkForSuccessMsg: function () {
		var msgCookie = dojo.cookie(MSG_COOKIE_NAME);
		if (msgCookie) {
			this.displaySuccessMessage(msgCookie, true);
			var now = new Date();
			now.setTime(now.getTime() - 1);
			dojo.cookie(MSG_COOKIE_NAME,EMPTY,{expires: now});
		}
	},
	
	checkForTeamInvitation: function () {
		var inviteCookie = dojo.cookie(TEAM_INVITATION_COOKIE_NAME);
		if (inviteCookie) {
			this.chooseTeamInvitees(dojo.fromJson(inviteCookie));
			
			var now = new Date();
			now.setTime(now.getTime() - 1);
			dojo.cookie(TEAM_INVITATION_COOKIE_NAME,EMPTY,{expires: now});
		}
	},
	
	clearState: function () {
		this.setDirty(false);
		this.selectedMembers = new Object();
		this.selectedAdmins = new Object();
		this.pendingMemberChanges = new Object();
		this.pendingAdminChanges = new Object();
		this.allMembers = new Array();
		this.allAdmins = new Array();
		this.parentProcessArea = null;
		this.name.value = EMPTY;
		this.summary.value = EMPTY;
		this.description.value = EMPTY;
		dojox.data.dom.removeChildren(this.processHierarchy);
		dojox.data.dom.removeChildren(this.developmentLineDiv);
		dojox.data.dom.removeChildren(this.memberArea);
		dojox.data.dom.removeChildren(this.adminArea);
		dojox.data.dom.removeChildren(this.messageBox);
		dojox.data.dom.removeChildren(this.longMessageBox);
		this.messageBox.className = EMPTY;
		this.longMessageBox.className = EMPTY;
		for (var i=0; i < this.inputFields.length; i++) {
			this.inputFields[i].changePending = false;
		}
	},
	
	handleTeamAreaFetchError: function (err) {
		var msg = document.createElement(DIV);
		msg.appendChild(document.createTextNode(this.messages.TeamAreaEditor_7));
		if (err.message != null && err.message != EMPTY) {
			msg.appendChild(document.createElement(BR));
			msg.appendChild(document.createElement(BR));
			msg.appendChild(document.createTextNode(err.message));
		}
		this.displayLongErrorMessage(msg);
	},
	
	togglePrimaryField: function (mode) {
		if (mode === MODE_PREVIEW) {
			this.name.style.display = NONE;
			dojox.data.dom.removeChildren(this.previewName);
			this.previewName.appendChild(document.createTextNode(this.name.value || this.messages.TeamAreaEditor_8));
			this.previewName.style.display = EMPTY;
		}
		else if (mode === MODE_EDIT) {
			this.previewName.style.display = NONE;
			this.name.style.display = EMPTY;
			this.name.focus();
			this.name.select();
			this.displayMessage(EMPTY,EMPTY);
		}
	},
	
	toggleViewEditMode: function (mode) {
		if (mode === MODE_PREVIEW) {
			dojo.forEach(this.editViewFields, function (field) {
				field.style.display = NONE;
				dojox.data.dom.removeChildren(field.viewElement);
				var previewString = field.value.substring(0,SHOW_TEXT_LENGTH);
				var hiddenString = field.value.substring(SHOW_TEXT_LENGTH);
				if (field.value.length > SHOW_TEXT_LENGTH) {
					var spaceIndex = hiddenString.indexOf(" "); //$NON-NLS-1$
					var newlineIndex = hiddenString.indexOf("\n"); //$NON-NLS-1$
					// if there is no good point to break the string in hiddenString, just show the whole thing
					if (spaceIndex === -1 && newlineIndex === -1) {
						previewString += hiddenString;
						hiddenString = EMPTY;
					}
					else if (newlineIndex === -1 || (spaceIndex !== -1 && spaceIndex < newlineIndex)) {
						previewString += hiddenString.substring(0, spaceIndex);
						hiddenString = hiddenString.substring(spaceIndex);
					}
					else if (spaceIndex === -1 || (newlineIndex !== -1 && newlineIndex < spaceIndex)) {
						previewString += hiddenString.substring(0, newlineIndex);
						hiddenString = hiddenString.substring(newlineIndex);
					}
				}
				var strings = previewString.split(/\n/);
				for (var i=0; i < strings.length; i++) {
					if (i > 0) {
						field.viewElement.appendChild(document.createElement(BR));
					}
					if (strings[i].length > 0) {
						field.viewElement.appendChild(document.createTextNode(strings[i]));
					}
				}
				field.viewElement.style.display = EMPTY;
				dojox.data.dom.removeChildren(field.viewAllElement);
				if (hiddenString != null && hiddenString !== EMPTY) {
					strings = hiddenString.split(/\n/);
					for (var i=0; i < strings.length; i++) {
						if (i > 0) {
							field.viewAllElement.appendChild(document.createElement(BR));
						}
						if (strings[i].length > 0) {
							field.viewAllElement.appendChild(document.createTextNode(strings[i]));
						}
					}
					if (field.showingAll) {
						field.viewAllElement.style.display = INLINE;
						field.showLessLink.style.display = BLOCK;
						field.showAllLink.style.display = NONE;
					}
					else {
						field.viewAllElement.style.display = NONE;
						field.showLessLink.style.display = NONE;
						field.showAllLink.style.display = BLOCK;
					}
				}
			});
			dojox.data.dom.removeChildren(this.toggleDescLink);
			this.toggleDescLink.appendChild(document.createTextNode(this.messages.TeamAreaEditor_9));
		}
		else if (mode === MODE_EDIT) {
			dojox.data.dom.removeChildren(this.toggleDescLink);
			this.toggleDescLink.appendChild(document.createTextNode(this.messages.TeamAreaEditor_10));
			dojo.forEach(this.editViewFields, function (field) {
				field.viewElement.style.display = NONE;
				field.viewAllElement.style.display = NONE;
				field.style.display = EMPTY;
				field.showAllLink.style.display = NONE;
				field.showLessLink.style.display = NONE;
			});
		}
	},
	
	populateTeamAreaData: function (data) {
		this.name.value = data.name;
		this.name.savedValue = data.name;
		this.togglePrimaryField(MODE_PREVIEW);
		this.summary.value = data.summary;
		this.summary.savedValue = data.summary;
		this.description.value = data.description;
		this.description.savedValue = data.description;
		if (data.description) {
			this.toggleViewEditMode(MODE_PREVIEW);
		}
		else {
			this.toggleViewEditMode(MODE_EDIT);
		}
		this.allProcessRoles = data.processDTO.roles;
		this.projectAreaName = data.processHierarchy.name;
		
		var teamArray = this.getAncestorsAsArray(data.processHierarchy);
		teamArray.shift();
		this.teamAreaPath = dojo.map(teamArray, "return '/'.concat(item.name)").join(EMPTY); //$NON-NLS-1$
		
		this.populateProcessHierarchy(data.processHierarchy);
		this.allMembers = data.members;
		this.allAdmins = data.admins;
		this.populateMembers(this.allMembers);
		this.populateAdmins(this.allAdmins);
		this.populateDevelopmentLine(data.developmentLine);
		this.checkForTeamInvitation();
	},
	
	populateMembers: function (members) {
		this.populateUsers(members, this.memberHeader, this.memberArea, !this.isNew, this.showingAllMembers, "memberRemoveHandler", "processRoleHandler", "teamInviteHandler"); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
		if (members != null && members.length > DEFAULT_DISPLAY_MAX) {
			if (this.showingAllMembers) {
				this.showFewerMembersLink.style.display = BLOCK;
				this.showAllMembersLink.style.display = NONE;
			}
			else {
				this.showFewerMembersLink.style.display = NONE;
				this.showAllMembersLink.style.display = BLOCK;
			}
		}
		else {
			this.showFewerMembersLink.style.display = NONE;
			this.showAllMembersLink.style.display = NONE;
		}
	},
	
	populateAdmins: function (admins) {
		this.populateUsers(admins, this.adminHeader, this.adminArea, false, this.showingAllAdmins, "adminRemoveHandler"); //$NON-NLS-1$
		if (admins != null && admins.length > DEFAULT_DISPLAY_MAX) {
			if (this.showingAllAdmins) {
				this.showFewerAdminsLink.style.display = BLOCK;
				this.showAllAdminsLink.style.display = NONE;
			}
			else {
				this.showFewerAdminsLink.style.display = NONE;
				this.showAllAdminsLink.style.display = BLOCK;
			}
		}
		else {
			this.showFewerAdminsLink.style.display = NONE;
			this.showAllAdminsLink.style.display = NONE;
		}
	},
	
	populateUsers: function (users, header, userArea, isNotNew, showAll, removeHandler, processRoleHandler, teamInviteHandler) {
		dojox.data.dom.removeChildren(header);
		var tr = document.createElement("tr"); //$NON-NLS-1$
		tr.className = "headerLineRow"; //$NON-NLS-1$
		var th = document.createElement("th"); //$NON-NLS-1$
		th.className = "memberName"; //$NON-NLS-1$
		if (dojo.isIE) {
			th.appendChild(document.createTextNode(" ")); //$NON-NLS-1$
		}
		tr.appendChild(th);
		if (isNotNew) {
			th = document.createElement("th"); //$NON-NLS-1$
			th.className = "memberRoles"; //$NON-NLS-1$
			if (dojo.isIE) {
				th.appendChild(document.createTextNode(" ")); //$NON-NLS-1$
			}
			tr.appendChild(th);
		}
		else {
			th = document.createElement("th"); //$NON-NLS-1$
			th.className = "memberMail"; //$NON-NLS-1$
			if (dojo.isIE) {
				th.appendChild(document.createTextNode(" ")); //$NON-NLS-1$
			}
			tr.appendChild(th);
		}
		th = document.createElement("th"); //$NON-NLS-1$
		th.className = "iconNode"; //$NON-NLS-1$
		if (dojo.isIE) {
			th.appendChild(document.createTextNode(" ")); //$NON-NLS-1$
		}
		tr.appendChild(th);
		header.appendChild(tr);
		tr = document.createElement("tr"); //$NON-NLS-1$
		th = document.createElement("th"); //$NON-NLS-1$
		th.appendChild(document.createTextNode(this.messages.TeamAreaEditor_11));
		th.className = "memberName"; //$NON-NLS-1$
		tr.appendChild(th);
		if (isNotNew) {
			th = document.createElement("th"); //$NON-NLS-1$
			th.appendChild(document.createTextNode(this.messages.TeamAreaEditor_12));
			th.className = "memberRoles"; //$NON-NLS-1$
			tr.appendChild(th);
		}
		else {
			th = document.createElement("th"); //$NON-NLS-1$
			th.appendChild(document.createTextNode(this.messages.TeamAreaEditor_13));
			th.className = "memberMail"; //$NON-NLS-1$
			tr.appendChild(th);
		}
		th = document.createElement("th"); //$NON-NLS-1$
		th.className = "iconNode"; //$NON-NLS-1$
		tr.appendChild(th);
		
		header.appendChild(tr);
		dojox.data.dom.removeChildren(userArea);
		if (users != null && users.length > 0) {
			for (var i=0; i < users.length; i++) {
				var tr = document.createElement("tr"); //$NON-NLS-1$
				tr.userObj = users[i];
				var td = document.createElement("td"); //$NON-NLS-1$
				td.className = "memberName"; //$NON-NLS-1$
				var link = document.createElement("a"); //$NON-NLS-1$
				if (users[i].archived) {
					link.href = "#action=" + ARCHIVED_USER_EDITOR + "&itemId=" + users[i].itemId; //$NON-NLS-1$ //$NON-NLS-2$
				}
				else {
					link.href = "#action=" + USER_EDITOR + "&itemId=" + users[i].itemId; //$NON-NLS-1$ //$NON-NLS-2$
				}
				link.appendChild(document.createTextNode(users[i].name));
				td.appendChild(link);
				tr.appendChild(td);
				if (isNotNew) {
					td = document.createElement("td"); //$NON-NLS-1$
					td.className = "memberRoles"; //$NON-NLS-1$
					var roleStr = EMPTY;
					if (users[i].processRoles != null) {
						users[i].savedProcessRoles = users[i].processRoles;
						var roleIds = new Array();
						for (var j=0; j < users[i].processRoles.length; j++) {
							// hide the default role from the display
							if (users[i].processRoles[j].id != "default") { //$NON-NLS-1$
								roleIds.push(users[i].processRoles[j].label);
							}
						}
						roleStr = roleIds.join(", "); //$NON-NLS-1$
					}
					if (dojo.isIE && roleStr === EMPTY) {
						roleStr = " "; //$NON-NLS-1$
					}
					td.appendChild(document.createTextNode(roleStr));
					tr.roleDisplay = td;
				}
				else {
					td = document.createElement("td"); //$NON-NLS-1$
					td.className = "memberMail"; //$NON-NLS-1$
					var link = document.createElement("a"); //$NON-NLS-1$
					link.href = "mailto:" + users[i].emailAddress; //$NON-NLS-1$
					link.appendChild(document.createTextNode(users[i].emailAddress));
					td.appendChild(link);
					tr.mailDisplay = td;
				}
				tr.appendChild(td);
				td = document.createElement("td"); //$NON-NLS-1$
				td.className = "iconNode"; //$NON-NLS-1$
				if (isNotNew && teamInviteHandler != null) {
					var teamInviteIcon = document.createElement("img"); //$NON-NLS-1$
					teamInviteIcon.src = dojo.moduleUrl("com.ibm.team.process.web", "ui/internal/admin/projects/images/team-invite.gif"); //$NON-NLS-1$ //$NON-NLS-2$
					teamInviteIcon.nohoverSrc = dojo.moduleUrl("com.ibm.team.process.web", "ui/internal/admin/projects/images/team-invite.gif"); //$NON-NLS-1$ //$NON-NLS-2$
					teamInviteIcon.hoverSrc = dojo.moduleUrl("com.ibm.team.process.web", "ui/internal/admin/projects/images/team-invite-hov.gif"); //$NON-NLS-1$ //$NON-NLS-2$
					this.connect(teamInviteIcon, "onclick", teamInviteHandler); //$NON-NLS-1$
					this.connectHandles.push(dojo.connect(teamInviteIcon, "onmouseover", teamInviteIcon, function (e) { //$NON-NLS-1$
						this.src = this.hoverSrc;
					}));
					this.connectHandles.push(dojo.connect(teamInviteIcon, "onmouseout", teamInviteIcon, function (e) { //$NON-NLS-1$
						this.src = this.nohoverSrc;
					}));
					teamInviteIcon.title = this.messages.TeamAreaEditor_38;
					td.appendChild(teamInviteIcon);
				}
				if (isNotNew) {
					var processRolesIcon = document.createElement("img"); //$NON-NLS-1$
					processRolesIcon.src = dojo.moduleUrl("com.ibm.team.process.web", "ui/internal/admin/projects/images/process-roles.gif"); //$NON-NLS-1$ //$NON-NLS-2$
					processRolesIcon.nohoverSrc = dojo.moduleUrl("com.ibm.team.process.web", "ui/internal/admin/projects/images/process-roles.gif"); //$NON-NLS-1$ //$NON-NLS-2$
					processRolesIcon.hoverSrc = dojo.moduleUrl("com.ibm.team.process.web", "ui/internal/admin/projects/images/process-roles-hov.gif"); //$NON-NLS-1$ //$NON-NLS-2$
					this.connect(processRolesIcon, ON_CLICK, processRoleHandler);
					this.connectHandles.push(dojo.connect(processRolesIcon, ON_MOUSEOVER, processRolesIcon, function (e) {
						this.src = this.hoverSrc;
					}));
					this.connectHandles.push(dojo.connect(processRolesIcon, ON_MOUSEOUT, processRolesIcon, function (e) {
						this.src = this.nohoverSrc;
					}));
					processRolesIcon.title = this.messages.TeamAreaEditor_14;
					td.appendChild(processRolesIcon);
				}
				var removeIcon = document.createElement("img"); //$NON-NLS-1$
				removeIcon.src = dojo.moduleUrl("com.ibm.team.process.web", "ui/internal/admin/projects/images/remove.gif"); //$NON-NLS-1$ //$NON-NLS-2$
				removeIcon.nohoverSrc = dojo.moduleUrl("com.ibm.team.process.web", "ui/internal/admin/projects/images/remove.gif"); //$NON-NLS-1$ //$NON-NLS-2$
				removeIcon.hoverSrc = dojo.moduleUrl("com.ibm.team.process.web", "ui/internal/admin/projects/images/remove-hov.gif"); //$NON-NLS-1$ //$NON-NLS-2$
				removeIcon.title = this.messages.TeamAreaEditor_15;
				this.connect(removeIcon,ON_CLICK,removeHandler);
				this.connectHandles.push(dojo.connect(removeIcon, ON_MOUSEOVER, removeIcon, function (e) {
					this.src = this.hoverSrc;
				}));
				this.connectHandles.push(dojo.connect(removeIcon, ON_MOUSEOUT, removeIcon, function (e) {
					this.src = this.nohoverSrc;
				}));
				td.appendChild(removeIcon);
				tr.appendChild(td);
				this.connectHandles.push(dojo.connect(tr, ON_MOUSEOVER, tr, function (e) {
					dojo.toggleClass(this, "highlighted", true); //$NON-NLS-1$
				}));
				this.connectHandles.push(dojo.connect(tr, ON_MOUSEOUT, function (e) {
					dojo.toggleClass(this, "highlighted", false); //$NON-NLS-1$
				}));
				if (!showAll && i >= DEFAULT_DISPLAY_MAX) {
					tr.style.display = NONE;
				}
				userArea.appendChild(tr);
			}
		}
	},
	
	memberRemoveHandler: function (e) {
		if (this.pendingMemberChanges["remove"] == null) { //$NON-NLS-1$
			this.pendingMemberChanges["remove"] = new Array(); //$NON-NLS-1$
		}
		var rowNode = e.target;
		while (rowNode.tagName !== "TR") { //$NON-NLS-1$
			rowNode = rowNode.parentNode;
		}
		var selectedUser = rowNode.userObj;
		var itemId = selectedUser.itemId;
		
		this.pendingMemberChanges.remove.push(itemId);
		for (var j=0; j < this.allMembers.length; j++) {
			if (itemId === this.allMembers[j].itemId) {
				this.allMembers.splice(j,1);
				break;
			}
		}
		if (this.pendingMemberChanges.add != null) {
			for (var j=0; j < this.pendingMemberChanges.remove.length; j++) {
				if (this.pendingMemberChanges.add[j] == itemId) {
					this.pendingMemberChanges.add.splice(j,1);
					break;
				}
			}
		}
		this.setDirty(true);
		this.populateMembers(this.allMembers);
	},
	
	processRoleHandler: function (e) {
		var rowNode = e.target;
		while (rowNode.tagName !== "TR") { //$NON-NLS-1$
			rowNode = rowNode.parentNode;
		}
		var selectedUser = rowNode.userObj;
		this.processRoleRow = rowNode;
		
		var workbenchNode = dojo.byId("workbench"); //$NON-NLS-1$
		var roleObj = new Object();
		roleObj.allRoles = this.allProcessRoles;
		roleObj.member = selectedUser;
		var dialogWidget = dijit.byId("com.ibm.team.process.web.ui.internal.admin.projects.ProcessRoleDialog"); //$NON-NLS-1$
		if (dialogWidget == null) {
			var processRoleDialog = new com.ibm.team.process.web.ui.internal.admin.projects.ProcessRoleDialog(roleObj, workbenchNode);
			dialogWidget = new net.jazz.ajax.ui.internal.Dialog({id:"com.ibm.team.process.web.ui.internal.admin.projects.ProcessRoleDialog", //$NON-NLS-1$
				primaryTitle: this.messages.TeamAreaEditor_16,
				contentNode: processRoleDialog.domNode,
				width: "52em", //$NON-NLS-1$ 
				startup: function() {
					processRoleDialog.startup();
				},
				execute: function(selectedRoles) {
					var roleIds = new Array();
					for (var i=0; i < selectedRoles.length; i++) {
						// hide the default role from the display
						if (selectedRoles[i].id != "default") { //$NON-NLS-1$
							roleIds.push(selectedRoles[i].label);
						}
					}
					var roleString = roleIds.join(", "); //$NON-NLS-1$
					var selectedRow = this.targetObj.processRoleRow;
					dojox.data.dom.removeChildren(selectedRow.roleDisplay);
					selectedRow.roleDisplay.appendChild(document.createTextNode(roleString));
					selectedRow.userObj.processRoles = selectedRoles;
					var roleChanged = false;
					if (selectedRoles.length == selectedRow.userObj.savedProcessRoles.length) {
						for (var j=0; j < selectedRoles.length; j++) {
							if (selectedRoles[j].id != selectedRow.userObj.savedProcessRoles[j].id) {
								roleChanged = true;
								break;
							}
						}
					}
					else {
						roleChanged = true;
					}
					if (roleChanged) {
						var roleArray = new Array();
						for (var j=0; j < selectedRow.userObj.processRoles.length; j++) {
							roleArray.push(selectedRow.userObj.processRoles[j].id);
						}
						if (this.targetObj.pendingMemberChanges["roles"] == null) { //$NON-NLS-1$
							this.targetObj.pendingMemberChanges["roles"] = new Object(); //$NON-NLS-1$
						}
						this.targetObj.pendingMemberChanges["roles"][selectedRow.userObj.itemId] = roleArray; //$NON-NLS-1$
					}
					else {
						if (this.targetObj.pendingMemberChanges["roles"] != null) { //$NON-NLS-1$
							delete this.targetObj.pendingMemberChanges["roles"][selectedRow.userObj.itemId]; //$NON-NLS-1$
							var roleChanges = false;
							for (var j in this.targetObj.pendingMemberChanges["roles"]) { //$NON-NLS-1$
								roleChanges = true;
								break;
							}
							if (!roleChanges) {
								delete this.targetObj.pendingMemberChanges["roles"]; //$NON-NLS-1$
							}
						}
					}
					if (this.targetObj.changesPending()) {
						this.targetObj.saveButton.disabled = false;
					}
					else {
						this.targetObj.saveButton.disabled = true;
					}
				}
			});
			dialogWidget.startup();
			dialogWidget.targetObj = this;
			dialogWidget.processRoleDialogObj = processRoleDialog;
			this.connectHandles.push(dojo.connect(processRoleDialog.cancelButton, ON_CLICK, dialogWidget, function (e) {
				dojo.stopEvent(e);
				this.close();
			}));
			this.connectHandles.push(dojo.connect(processRoleDialog.finishButton, ON_CLICK, dialogWidget, function (e) {
				this.execute(this.processRoleDialogObj.getChosenRoles());
				this.close();
			}));
		}
		else {
			dialogWidget.processRoleDialogObj.repopulate(roleObj);
			dialogWidget.targetObj = this;
		}
	},
	
	teamInviteHandler: function (e) {
		var rowNode = e.target;
		while (rowNode.tagName !== "TR") { //$NON-NLS-1$
			rowNode = rowNode.parentNode;
		}
		var selectedUser = rowNode.userObj;
		this.customizeAndSendTeamInvitation([ rowNode.userObj.itemId ], rowNode.userObj, false);
	},
		
    createInvitationPropertiesString: function(user, repoLink) {
		return dojo.string.substitute("teamRepository=${0}\nuserId=${1}\nuserName=${2}\nprojectAreaName=${3}\nteamAreaPath=${4}", [ repoLink, user.userId, user.name, this.projectAreaName, this.teamAreaPath ]); //$NON-NLS-1$
	},
		
    customizeAndSendTeamInvitation: function(invitees, singleUser, showLink) {
		var emailObj = new Object();
		var projectAreaName = EMPTY;
		
		emailObj.subject = dojo.string.substitute(this.messages.TeamAreaEditor_37, [ this.name.value ]);
		
		var host = document.location.protocol + "//" + document.location.host + net.jazz.ajax._contextRoot; //$NON-NLS-1$
		var link = dojo.string.substitute("${0}/web/projects/${1}", [ host, this.projectAreaName]); //$NON-NLS-1$
		link = encodeURI(link);
		emailObj.message = dojo.string.substitute(this.messages.TeamAreaEditor_36, [ this.name.value, link ]);
		
		if (invitees.length == 1) {
    		emailObj.description = dojo.string.substitute(this.messages.TeamAreaEditor_34, [ singleUser.name ]);
			emailObj.singleUserObj = singleUser;
			emailObj.properties = this.createInvitationPropertiesString(singleUser, host); //$NON-NLS-1$
		} else {
    		emailObj.description = this.messages.TeamAreaEditor_35;
		}
		var teamAreaId = this.itemId;
		
		var workbenchNode = dojo.byId("workbench"); //$NON-NLS-1$
		var dialogWidget = dijit.byId("com.ibm.team.process.web.ui.internal.admin.projects.ProcessRoleDialog"); //$NON-NLS-1$
		if (dialogWidget == null) {
			var invitationDialog = new com.ibm.team.process.web.ui.internal.admin.projects.InvitationCustomizationDialog(emailObj, workbenchNode);
			dialogWidget = new net.jazz.ajax.ui.internal.Dialog({id:"com.ibm.team.process.web.ui.internal.admin.projects.InvitationCustomizationDialog", //$NON-NLS-1$
				primaryTitle: this.messages.TeamAreaEditor_38,
				contentNode: invitationDialog.domNode,
				width: dojo.isIE ? "48em" : "46em", //$NON-NLS-1$ //$NON-NLS-2$
				execute: function(dialogObj){
						var params = {
							subject: dialogObj.getEmailSubject(),
							message: dialogObj.getEmailBody(),
							cc: dialogObj.getCopySelf() ? getAuthenticatedContributor().emailAddress : EMPTY,
							teamAreaUuid: teamAreaId
						};
						params["jsonInvitees"] = dojo.toJson(invitees); //$NON-NLS-1$
						var srh = new ServiceResponseHandler(this.targetObj, "handleInvitationResponse", "handleInvitationError"); //$NON-NLS-1$ //$NON-NLS-2$
						this.targetObj.showLink = showLink;
						if (invitees.length == 1) {
							this.targetObj.messageToDisplay = this.targetObj.messages.TeamAreaEditor_42;
						} else {
							this.targetObj.messageToDisplay = this.targetObj.messages.TeamAreaEditor_41;
						}
						ProcessClient.generateTeamInvitations(params, srh);
        				this.targetObj.displayPendingMessage(this.targetObj.messages.TeamAreaEditor_39);
				}	
			});
			dialogWidget.targetObj = this;
			dialogWidget.invitationDialogObj = invitationDialog;
			invitationDialog.emailSubject.focus();
			this.connectHandles.push(dojo.connect(invitationDialog.cancelButton, "onclick", dialogWidget, function (e) { //$NON-NLS-1$
				dojo.stopEvent(e);
				this.close();
			}));
			this.connectHandles.push(dojo.connect(invitationDialog.finishButton, "onclick", dialogWidget, function (e) { //$NON-NLS-1$
				this.execute(this.invitationDialogObj);
				this.close();
			}));
		}
		else {
			dialogWidget.invitationDialogObj.reset(emailObj);
			dialogWidget.targetObj = this;
		}
	},
	
	chooseTeamInvitees: function(newMemberIds) {
		var newMemberArray = new Array();
		dojo.forEach(newMemberIds, function(itemId) {
			dojo.forEach(this.allMembers, function(member) {
				if (member.itemId === itemId) {
					newMemberArray.push(member);
				}
			})
		}, this);

		var mixinObj = new Object();
		mixinObj.newMembers = newMemberArray;
		
		var workbenchNode = dojo.byId("workbench"); //$NON-NLS-1$
		var dialogWidget = dijit.byId("com.ibm.team.process.web.ui.internal.admin.projects.TeamInvitationDialog"); //$NON-NLS-1$
		var self = this;
		if (dialogWidget == null) {
			var teamInvitationDialog = new com.ibm.team.process.web.ui.internal.admin.projects.TeamInvitationDialog(mixinObj, workbenchNode);
			dialogWidget = new net.jazz.ajax.ui.internal.Dialog({id:"com.ibm.team.process.web.ui.internal.admin.projects.TeamInvitationDialog", //$NON-NLS-1$
				primaryTitle: this.messages.TeamAreaEditor_40,
				contentNode: teamInvitationDialog.domNode,
				width: dojo.isIE ? "38em" : "36em", //$NON-NLS-1$ //$NON-NLS-2$
				execute: function() {
					var invitees = this.teamInvitationDialogObj.getChosenMembers();
					if (invitees.length > 0) {
						self.customizeAndSendTeamInvitation(invitees, this.teamInvitationDialogObj.singleUser, true);
					}
				}
			});
			dialogWidget.targetObj = this;
			dialogWidget.teamInvitationDialogObj = teamInvitationDialog;
			teamInvitationDialog.okButton.focus();
			this.connectHandles.push(dojo.connect(teamInvitationDialog.cancelButton, "onclick", dialogWidget, function (e) { //$NON-NLS-1$
				dojo.stopEvent(e);
				this.close();
			}));
			this.connectHandles.push(dojo.connect(teamInvitationDialog.okButton, "onclick", dialogWidget, function (e) { //$NON-NLS-1$
				this.execute();
				this.close();
			}));
		}
		else {
			dialogWidget.teamInvitationDialogObj.repopulate(membersObj);
			dialogWidget.targetObj = this;
		}
	},
	
	handleInvitationResponse: function(response) {
		this.displaySuccessMessage(this.messageToDisplay, this.showLink);
	},
	
	handleInvitationError: function(err) {
		var msg = document.createElement(DIV);
		msg.appendChild(document.createTextNode(this.messages.TeamAreaEditor_43));
		if (err.message != null && err.message != EMPTY) {
			msg.appendChild(document.createElement(BR));
			msg.appendChild(document.createElement(BR));
			msg.appendChild(document.createTextNode(err.message));
		}
		this.displayLongErrorMessage(msg);
	},
	
	adminRemoveHandler: function (e) {
		if (this.pendingAdminChanges["remove"] == null) { //$NON-NLS-1$
			this.pendingAdminChanges["remove"] = new Array(); //$NON-NLS-1$
		}
		var rowNode = e.target;
		while (rowNode.tagName !== "TR") { //$NON-NLS-1$
			rowNode = rowNode.parentNode;
		}
		var selectedUser = rowNode.userObj;
		var itemId = selectedUser.itemId;
		
		this.pendingAdminChanges.remove.push(itemId);
		for (var j=0; j < this.allAdmins.length; j++) {
			if (itemId === this.allAdmins[j].itemId) {
				this.allAdmins.splice(j,1);
				break;
			}
		}
		if (this.pendingAdminChanges.add != null) {
			for (var j=0; j < this.pendingAdminChanges.remove.length; j++) {
				if (this.pendingAdminChanges.add[j] == itemId) {
					this.pendingAdminChanges.add.splice(j,1);
					break;
				}
			}
		}
		this.setDirty(true);
		this.populateAdmins(this.allAdmins);
	},
	
	addNewMembers: function (newMembers) {
		if (newMembers != null) {
			if (newMembers.length > 0) {
				this.setDirty(true);
				if (this.pendingMemberChanges["add"] == null) { //$NON-NLS-1$
					this.pendingMemberChanges["add"] = new Array(); //$NON-NLS-1$
				}
			}
			var defaultRoleLabel = this.getDefaultRoleLabel();
			for (var i=0; i < newMembers.length; i++) {
				var member = newMembers[i];
				member.itemId = member.itemId;
				member.processRoles = [{id: "default", label: defaultRoleLabel}]; //$NON-NLS-1$
				member.savedProcessRoles = [{id: "default", label: defaultRoleLabel}]; //$NON-NLS-1$
				this.allMembers.push(member);
				this.pendingMemberChanges.add.push(member.itemId);
				if (this.pendingMemberChanges.remove != null) {
					for (var j=0; j < this.pendingMemberChanges.remove.length; j++) {
						if (this.pendingMemberChanges.remove[j] == member.itemId) {
							this.pendingMemberChanges.remove.splice(j,1);
							break;
						}
					}
				}
			}
		}
		this.populateMembers(this.allMembers);
	},
	
	addNewAdmins: function (newAdmins) {
		if (newAdmins != null) {
			if (newAdmins.length > 0) {
				this.setDirty(true);
				if (this.pendingAdminChanges["add"] == null) { //$NON-NLS-1$
					this.pendingAdminChanges["add"] = new Array(); //$NON-NLS-1$
				}
			}
			for (var i=0; i < newAdmins.length; i++) {
				var admin = newAdmins[i];
				admin.itemId = admin.itemId;
				admin.processRoles = [{id: "default"}]; //$NON-NLS-1$
				admin.savedProcessRoles = [{id: "default"}]; //$NON-NLS-1$
				this.allAdmins.push(admin);
				this.pendingAdminChanges.add.push(admin.itemId);
				if (this.pendingAdminChanges.remove != null) {
					for (var j=0; j < this.pendingAdminChanges.remove.length; j++) {
						if (this.pendingAdminChanges.remove[j] == admin.itemId) {
							this.pendingAdminChanges.remove.splice(j,1);
							break;
						}
					}
				}
			}
		}
		this.populateAdmins(this.allAdmins);
	},
	
	getDefaultRoleLabel : function() {
		if (this.allProcessRoles) {
			for (var i = 0; i < this.allProcessRoles.length; i++) {
				if (this.allProcessRoles[i].id === "default") {
					return this.allProcessRoles[i].label;
				}
			}
		}
		return "default"; //$NON-NLS-1$
	},
	
	populateDevelopmentLine: function (data) {
		dojox.data.dom.removeChildren(this.developmentLineDiv);
		if (data != null && data.label != null) {
			this.developmentLineDiv.appendChild(document.createTextNode(data.label));
		}
		else {
			this.developmentLineDiv.appendChild(document.createTextNode(this.messages.TeamAreaEditor_17));
		}
	},
	
	populateDevelopmentLineSelector: function () {
		dojox.data.dom.removeChildren(this.developmentLineDiv);
		if (this.parentProcessArea != null) {
			if (this.parentProcessArea.type == "projectArea") { //$NON-NLS-1$
				var srh = new ServiceResponseHandler(this, "developmentLineSelectorCallback", "handleProjectDevLineQueryError"); //$NON-NLS-1$ //$NON-NLS-2$
				ProcessClient.getProjectDevelopmentLines({uuid: this.parentProcessArea.itemId}, srh);
			}
			else if (this.parentProcessArea.type == "teamArea") { //$NON-NLS-1$
				var srh = new ServiceResponseHandler(this, "developmentLineDisplayCallback", "handleTeamDevLineQueryError"); //$NON-NLS-1$ //$NON-NLS-2$
				ProcessClient.getTeamAreaByUUID({uuid: this.parentProcessArea.itemId}, srh);
			}
		}
		else {
			this.developmentLineDiv.appendChild(document.createTextNode(this.messages.TeamAreaEditor_18));
		}
	},
	
	handleProjectDevLineQueryError: function (err) {
		var msg = document.createElement(DIV);
		msg.appendChild(document.createTextNode(this.messages.TeamAreaEditor_19));
		if (err.message != null && err.message != EMPTY) {
			msg.appendChild(document.createElement(BR));
			msg.appendChild(document.createElement(BR));
			msg.appendChild(document.createTextNode(err.message));
		}
		this.displayLongErrorMessage(msg);
	},
	
	handleTeamDevLineQueryError: function (err) {
		var msg = document.createElement(DIV);
		msg.appendChild(document.createTextNode(this.messages.TeamAreaEditor_20));
		if (err.message != null && err.message != EMPTY) {
			msg.appendChild(document.createElement(BR));
			msg.appendChild(document.createElement(BR));
			msg.appendChild(document.createTextNode(err.message));
		}
		this.displayLongErrorMessage(msg);
	},
	
	developmentLineSelectorCallback: function (data) {
		dojox.data.dom.removeChildren(this.developmentLineDiv);
		if (data != null && data.length > 0) {
			var select = document.createElement("select"); //$NON-NLS-1$
			this.developmentLineSelector = select;
			for (var i=0; i < data.length; i++) {
				var option = new Option(data[i].label, data[i].itemId);
				if (data[i].summary != null && data[i].summary != EMPTY) {
					option.description = data[i].summary;
				}
				else if (data[i].description != null && data[i].description != EMPTY) {
					option.description = data[i].description;
				}
				else {
					option.description = this.messages.TeamAreaEditor_21;
				}
				if (dojo.isIE) {
					select.options[select.options.length] = option;
				}
				else {
					select.appendChild(option);
				}
			}
			this.developmentLineDiv.appendChild(select);
		}
		else {
			this.developmentLineDiv.appendChild(document.createTextNode(this.messages.TeamAreaEditor_22));
		}
	},
	
	developmentLineDisplayCallback: function (data) {
		this.populateDevelopmentLine(data.developmentLine);
	},
	
	populateProcessHierarchy: function (project) {
		dojox.data.dom.removeChildren(this.processHierarchy);
		this.showBreadcrumbs(this.isArchived, this.getAncestorsAsArray(project));
		var div = document.createElement(DIV);
		var link = document.createElement("a"); //$NON-NLS-1$
		link.href = "#action=" + PROJECT_AREA_EDITOR + "&itemId=" + project.itemId; //$NON-NLS-1$ //$NON-NLS-2$
		link.tabIndex = 3;
		link.appendChild(document.createTextNode(project.name));
		div.appendChild(link);
		div.className = "hierarchyElement"; //$NON-NLS-1$
		this.processHierarchy.appendChild(div);
		var isNewParent = false;
		if (this.isNew && project.itemId === this.parentItemId) {
			this.parentProcessArea = {
				name: project.name,
				itemId: project.itemId,
				type: "projectArea" //$NON-NLS-1$
			};
			isNewParent = true;
		}
		if (project.children != null && project.children.length > 0) {
			this.populateRemainingHierarchy(project.children, 1, isNewParent);
		}
		else {
			if (isNewParent) {
				this.populateRemainingHierarchy([], 1, true);
			}
		}
		this.populateDevelopmentLineSelector();
	},
	
	populateRemainingHierarchy: function (teams, indent, includeNewTeam) {
		teams.sort(function (a,b) {
			return a.name > b.name ? 1 : a.name < b.name ? -1 : 0;
		});
		dojo.forEach(teams, dojo.hitch(this, function (team) {
			var div = document.createElement(DIV);
			var link = document.createElement("a"); //$NON-NLS-1$
			link.href = "#action=" + TEAM_AREA_EDITOR + "&itemId=" + team.itemId; //$NON-NLS-1$ //$NON-NLS-2$
			link.tabIndex = 3;
			link.appendChild(document.createTextNode(team.name));
			div.appendChild(link);
			div.className = "hierarchyElement"; //$NON-NLS-1$
			if (!this.isNew && this.itemId === team.itemId) {
				div.className += " selected"; //$NON-NLS-1$
				this.hierarchyNameDisplay = div;
			}
			div.style.paddingLeft = (15 * indent) + "px"; //$NON-NLS-1$
			this.processHierarchy.appendChild(div);
			var isNewParent = false;
			if (this.isNew && team.itemId === this.parentItemId) {
				this.parentProcessArea = {
					name: team.name,
					itemId: team.itemId,
					type: "teamArea" //$NON-NLS-1$
				};
				isNewParent = true;
			}
			if (team.children != null && team.children.length > 0) {
				this.populateRemainingHierarchy(team.children, indent + 1, isNewParent);
			}
			else {
				if (isNewParent) {
					this.populateRemainingHierarchy([], indent + 1, true);
				}
			}
		}));
		if (includeNewTeam) {
			var div = document.createElement(DIV);
			this.hierarchyNameDisplay = div;
			div.className = "hierarchyElement selected"; //$NON-NLS-1$
			div.style.paddingLeft = (15 * indent) + "px"; //$NON-NLS-1$
			div.appendChild(document.createTextNode(this.messages.TeamAreaEditor_23));
			this.processHierarchy.appendChild(div);
		}
	},
	
	// returns an array representing the process hierarchy directly above this team area
	getAncestorsAsArray: function (processArea) {
		var foundParentOfNewTeam = this.isNew && this.parentItemId === processArea.itemId;
		var foundThisTeam = !this.isNew && this.itemId === processArea.itemId;
		var hasChildren = processArea.children && processArea.children.length > 0;
		
		// Return an array containing this process area so it can bubble up recursively
		// The recursive callers will insert their process area at the front of this array so
		// we get a complete ancestry array in the end 
		if (foundParentOfNewTeam || foundThisTeam) {
			return [ processArea ];
		}
		else if (hasChildren) {
			for (var i=0; i < processArea.children.length; i++) {
				var curLine = this.getAncestorsAsArray(processArea.children[i]);
				// If the current child team exists along the ancestry path, we know this element
				// also belongs along the ancestry path.  Add the current processArea to the front
				// of the ancestry path and bubble up to the next recursive caller.
				if (curLine) {
					curLine.unshift(processArea);
					return curLine;
				}
			}
		}
		else {
			// We didn't find what we were looking for down this branch.
			// Return null so the recursive callers will ignore this path.
			return null;
		}
	},
	
	showBreadcrumbs: function (isArchived, hierarchy) {
		dojox.data.dom.removeChildren(this.breadcrumbs);
		var link = document.createElement("a"); //$NON-NLS-1$
		link.href = isArchived ? "#action=" + ARCHIVED_MANAGER : "#action=" + MANAGER; //$NON-NLS-1$ //$NON-NLS-2$
		link.appendChild(document.createTextNode(isArchived ? this.messages.TeamAreaEditor_24 : this.messages.TeamAreaEditor_25));
		this.breadcrumbs.appendChild(link);
		var span = document.createElement("span"); //$NON-NLS-1$
		span.appendChild(document.createTextNode(">")); //$NON-NLS-1$
		this.breadcrumbs.appendChild(span);
		for (var i=0; i < hierarchy.length; i++) {
			// Don't include the current element in the breadcrumb hierarchy
			if (!this.isNew && i === hierarchy.length - 1) {
				continue;
			}
			link = document.createElement("a"); //$NON-NLS-1$
			if (i === 0) {
				link.href = "#action=" + PROJECT_AREA_EDITOR + "&itemId=" + hierarchy[i].itemId; //$NON-NLS-1$ //$NON-NLS-2$
			}
			else {
				link.href = "#action=" + TEAM_AREA_EDITOR + "&itemId=" + hierarchy[i].itemId; //$NON-NLS-1$ //$NON-NLS-2$
			}
			link.appendChild(document.createTextNode(hierarchy[i].name));
			this.breadcrumbs.appendChild(link);
			span = document.createElement("span"); //$NON-NLS-1$
			span.appendChild(document.createTextNode(">")); //$NON-NLS-1$
			this.breadcrumbs.appendChild(span);
		}
	},
	
	handleChange: function (e) {
		if (e.target.value != e.target.savedValue) {
			e.target.changePending = true;
			this.setDirty(true);
		}
		else {
			e.target.changePending = false;
			if (!this.changesPending()) {
				this.setDirty(false);
			}
		}
	},
	
	setDirty: function (isDirty) {
		this.saveButton.disabled = !isDirty;
		if (isDirty) {
			this.modifiedFlag.style.display = INLINE;
		}
		else {
			this.modifiedFlag.style.display = NONE;
		}
	},
	
	changesPending: function () {
		for (var i=0; i < this.inputFields.length; i++) {
			if (this.inputFields[i].changePending) {
				return true;
			}
		}
		for (var i in this.pendingMemberChanges) {
			return true;
		}
		for (var i in this.pendingAdminChanges) {
			return true;
		}
		return false;
	},
	
	handleSave: function (e) {
		dojo.stopEvent(e);
		this.saveButton.disabled = true;
		var saveObj = {
			itemId: this.itemId
		};
		for (var i=0; i < this.inputFields.length; i++) {
			if (this.inputFields[i].changePending) {
				saveObj[this.inputFields[i].name] = this.inputFields[i].value;
			}
		}
		saveObj["jsonMembers"] = dojo.toJson(this.pendingMemberChanges); //$NON-NLS-1$
		saveObj["jsonAdmins"] = dojo.toJson(this.pendingAdminChanges); //$NON-NLS-1$
		if (this.isNew && this.parentProcessArea != null) {
			saveObj["jsonParentProcessArea"] = dojo.toJson(this.parentProcessArea); //$NON-NLS-1$
		}
		if (this.developmentLineSelector != null && this.developmentLineSelector.value != null) {
			saveObj["developmentLineUuid"] = this.developmentLineSelector.value; //$NON-NLS-1$
		}
		var msg = this.validateRequired(saveObj);
		if (msg != null && msg != EMPTY) {
			this.displayErrorMessage(msg);
		}
		else {
			var srh = new ServiceResponseHandler(this, "handleSaveResponse", "handleSaveError"); //$NON-NLS-1$ //$NON-NLS-2$
			ProcessClient.postTeamArea(saveObj, srh);
			this.displayPendingMessage(this.messages.TeamAreaEditor_26);
		}
	},
	
	validateRequired: function (saveData) {
		if (saveData.name == EMPTY || (this.isNew && saveData.name == null)) {
			this.togglePrimaryField(MODE_EDIT);
			return this.messages.TeamAreaEditor_27;
		}
		if (this.isNew && (saveData.jsonParentProcessArea == null || saveData.jsonParentProcessArea == EMPTY)) {
			return this.messages.TeamAreaEditor_28;
		}
	},
	
	handleSaveResponse: function (response) {
		if (this.pendingMemberChanges.add != null && this.pendingMemberChanges.add.length > 0) {
			var currentUser = getAuthenticatedContributor();
			var newMemberIds = dojo.filter(this.pendingMemberChanges.add, function(memberId) {
				return memberId != currentUser.itemId;
			});
			if (newMemberIds.length > 0) {
				if (this.isNew && response) {
					// in this case we'll be destroying the page and creating a new one
					// so we have to save the member ids in a cookie
					dojo.cookie(TEAM_INVITATION_COOKIE_NAME, dojo.toJson(newMemberIds));
				} else {
					// not destroying the page, so call directly
        			this.chooseTeamInvitees(newMemberIds);
				}
			}
		}
		
		if (this.isNew && response) {
			dojo.cookie(MSG_COOKIE_NAME, this.messages.TeamAreaEditor_29);
			PlatformUI.getWorkbench().unregisterBodyClickHandler(this.navigateAwayHandle);
			this.navigateAwayHandle = null;
			PlatformUI.getWorkbench().unregisterOnBeforeUnloadHandler(this.onBeforeUnloadHandle);
			this.onBeforeUnloadHandle = null;
			document.location.href = "#action=" + TEAM_AREA_EDITOR + "&itemId=" + response; //$NON-NLS-1$ //$NON-NLS-2$
		}
		else {
			this.refresh();
			this.displaySuccessMessage(this.messages.TeamAreaEditor_30, true);
		}
	},
	
	handleSaveError: function (err) {
		this.saveButton.disabled = false;
		var msg = document.createElement(DIV);
		msg.appendChild(document.createTextNode(this.messages.TeamAreaEditor_31));
		if (err.message != null && err.message != EMPTY) {
			msg.appendChild(document.createElement(BR));
			msg.appendChild(document.createElement(BR));
			msg.appendChild(document.createTextNode(err.message));
		}
		this.displayLongErrorMessage(msg);
	},
	
	ignoreError: function (err) {},
	
	onRefresh: function(e){
		dojo.stopEvent(e);
		if (this.changesPending() && !confirm(this.messages.TeamAreaEditor_32)) {
			return;
		}
		this.refresh();
	},
	
	displaySuccessMessage: function (msg, showManagerLink) {
		this.displayMessage(msg,"successMsg"); //$NON-NLS-1$
		if (showManagerLink) {
			this.messageBox.appendChild(document.createTextNode(" ")); //$NON-NLS-1$
			var link = document.createElement("a"); //$NON-NLS-1$
			link.href = "#action=" + MANAGER; //$NON-NLS-1$
			link.appendChild(document.createTextNode(this.messages.TeamAreaEditor_33));
			this.messageBox.appendChild(link);
		}
	},
	
	displayPendingMessage: function (msg) {
		this.displayMessage(msg, "pendingMsg"); //$NON-NLS-1$
	},
	
	displayErrorMessage: function (msg) {
		this.displayMessage(msg, "errorMsg"); //$NON-NLS-1$
	},
	
	displayMessage: function (msg, cssClass) {
		dojox.data.dom.removeChildren(this.messageBox);
		dojox.data.dom.removeChildren(this.longMessageBox);
		this.longMessageBox.className = EMPTY;
		this.messageBox.className = "message shortMsg " + cssClass; //$NON-NLS-1$
		this.messageBox.appendChild(document.createTextNode(msg));
	},
	
	displayLongSuccessMessage: function (msg) {
		if (dojo.isString(msg)) {
			msg = document.createTextNode(msg);
		}
		this.displayLongMessage(msg,"successMsg"); //$NON-NLS-1$
	},
	
	displayLongErrorMessage: function (msg) {
		if (dojo.isString(msg)) {
			msg = document.createTextNode(msg);
		}
		this.displayLongMessage(msg, "errorMsg"); //$NON-NLS-1$
	},
	
	displayLongMessage: function (msg, cssClass) {
		dojox.data.dom.removeChildren(this.messageBox);
		this.messageBox.className = EMPTY;
		dojox.data.dom.removeChildren(this.longMessageBox);
		this.longMessageBox.className = "message longMsg " + cssClass; //$NON-NLS-1$
		this.longMessageBox.appendChild(msg);
	},
	
	destroy: function () {
		dojo.forEach(this.connectHandles, function (handle) {
			dojo.disconnect(handle);
		});
		this.inherited(arguments);
	}
});

})();