/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005-2008. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.apt.web.ui.internal.common.Assert"); //$NON-NLS-1$

(function() {

function isLegal(expression, message) {
	if (!expression)
		_throwException("Illegal Argument", message); //$NON-NLS-1$
};
	
function isNotNull(expression, message) {
	if (expression == null)
		_throwException("Assertion Failed (null element)", message); //$NON-NLS-1$
};
	
function isTrue(expression, message) {
	if (!expression)
		_throwException("Assertion Failed", message); //$NON-NLS-1$
};

// ---- implementation -------------------------------------------------------------------------------------------------

function _throwException(exceptionKind, message) {
	var errorText= exceptionKind;
	if (dojo.isString(message)) {
		errorText+= ": " + message; //$NON-NLS-1$
	}

	console.log(errorText);
	throw new Error(errorText);
};

// publish methods
dojo.mixin(com.ibm.team.apt.web.ui.internal.common.Assert,  {
	isLegal: isLegal,
	isNotNull: isNotNull,
	isTrue: isTrue
});

})();
