/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005-2008. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.apt.web.ui.internal.view.plan.planneditems.WorkItemWidget"); //$NON-NLS-1$


dojo.require("com.ibm.team.apt.web.client.util"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.web.ui.internal.view.common.TableTreeItem"); //$NON-NLS-1$

(function() {

var PlanningUtil		= com.ibm.team.apt.web.client.util;
var TableTreeItem		= com.ibm.team.apt.web.ui.internal.view.common.TableTreeItem;

dojo.declare("com.ibm.team.apt.web.ui.internal.view.plan.planneditems.WorkItemWidget", //$NON-NLS-1$
			 [com.ibm.team.apt.web.ui.internal.view.common.TableTreeItem], {

	// ---- constructor mixed-in properties --------------------------------------------------------------------------------	

	_workItem: null,
	_options: null,
	_plannedItemsTab: null,

	// ---- api ------------------------------------------------------------------------------------------------------------	

	getWorkItem: function() {
		return this._workItem;
	},

	getReferencedItem: function(type, id) {
		return this._plannedItemsTab._getItem(type, id) || this._getDefaultItem(type, id);
	},

	// ---- widget implementation ------------------------------------------------------------------------------------------

	postCreate: function() {
		this.inherited(arguments);
		
		var rowContainer= this._getRowContainer();
		var columnSpanCount= 0;
		dojo.forEach(this._plannedItemsTab.getColumnDefinitions(), dojo.hitch(this, function(columnDefinition) {
			if (--columnSpanCount > 0) {
				return;
			}
			
			if (this._options.overrideColumn != null && columnDefinition == this._options.overrideColumn.column) {
				columnDefinition= this._options.overrideColumn.replacement;
				columnSpanCount= this._options.overrideColumn.columnSpan || 1;
			}
			var cell= columnDefinition.createCell(this);
			if (columnSpanCount > 1) {
				cell.colSpan= columnSpanCount;
			}
			rowContainer.appendChild(cell);
		}));
		
		dojo.toggleClass(rowContainer, "placeholder", this._options.isPlaceholder); //$NON-NLS-1$
		dojo.toggleClass(rowContainer, "auxiliary", this._workItem.auxiliary); //$NON-NLS-1$
		dojo.toggleClass(rowContainer, "resolved", this._workItem.resolved); //$NON-NLS-1$

		this._applyTreeLayout(true);
	},

	// ---- implementation -------------------------------------------------------------------------------------------------

	_getDefaultItem: function(type, id) {
		console.log("Unknown referenced value! type: " + type + " id: " + id); //$NON-NLS-1$ //$NON-NLS-2$
		 return {
			itemId: id,
			itemType: type,
			iconURL: dojo.moduleUrl("com.ibm.team.apt.web", "ui/internal/view/plan/images/error.gif"), //$NON-NLS-1$ //$NON-NLS-2$
			label: ("Unknown") //$NON-NLS-1$
		}
	},

	__sentinel: null // terminates this class definition
});

com.ibm.team.apt.web.ui.internal.view.plan.planneditems.WorkItemWidget.constructorArgs= function(workItem, options, parentItem, plannedItemsTab) {
	var result= {
		_workItem: workItem,
		_options: options,
		_plannedItemsTab: plannedItemsTab
	};
	
	return dojo.mixin(result, TableTreeItem.constructorArgs(parentItem, "workItem")); //$NON-NLS-1$
};

})();
