/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2008. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.workitem.web.ui.internal.view.query.QueryUtility");

dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler");
dojo.require("com.ibm.team.workitem.web.client.internal.WorkItemClient");
dojo.require("com.ibm.team.workitem.web.client.util");
dojo.require("net.jazz.ajax.toolbox.lang.internal.Lang");

(function() {

var ServiceResponseHandler	= com.ibm.team.repository.web.transport.ServiceResponseHandler;
var WorkItemClient			= com.ibm.team.workitem.web.client.internal.WorkItemClient;
var WorkItemUtil 			= com.ibm.team.workitem.web.client.util;
var checkNonNegative 		= net.jazz.ajax.toolbox.lang.checkNonNegative;

dojo.declare("com.ibm.team.workitem.web.ui.internal.view.query.QueryUtility", null,	{
	
	// internal constructor; do not call
	constructor: function(controller) {
		this.controller = controller;
	},
	
	runQuery: function(query, startIndex, maxNumberOfResults, clearResults, successCallback, errorCallback, callbackArgs) {
		if(startIndex) {
			checkNonNegative(startIndex, "startIndex");
		} 

		if (maxNumberOfResults != -1) {
			checkNonNegative(maxNumberOfResults, "maxNumberOfResults");
		} else {
			maxNumberOfResults= WorkItemUtil._getDefaultQueryPageSize();
		}
	
		// it's legal for any or all of the vars above to be null/undefined
		// since they simply restrict the query results
		var appArgs= {};
		if (query.categoryItemId) { appArgs.categoryItemId= query.categoryItemId; }
		if (query.ownerItemId)   { appArgs.ownerItemId=   query.ownerItemId; }
		if (query.status)        { appArgs.status=        query.status; }
		if (query.keywords)      { appArgs.keywords=      query.keywords; }
		if (query.pattern)		 { appArgs.pattern=       query.pattern; }
		
		if (startIndex) { appArgs.startIndex = startIndex; }
		if (maxNumberOfResults) { appArgs.maxNumberOfResults = maxNumberOfResults; }
		
		var self = this;
		
		var serviceObject = {
			queryCallback: function(queryResultsSummaryPage) {
				successCallback.call(self.controller, queryResultsSummaryPage, query, callbackArgs);
			},
			
			errorCallback: function(e) {
				errorCallback.call(self.controller, e);
			}
		};
		
		var responseHandler = new ServiceResponseHandler(serviceObject,	"queryCallback", "errorCallback");
				
		WorkItemClient.getWorkItemSummaryPage(responseHandler, appArgs);
	}

});
})();
 