/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2008. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.workitem.web.ui.internal.view.queryeditor.PopupButton");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");	
dojo.require("dijit.Menu");
dojo.require("dojox.data.dom");
dojo.require("net.jazz.ajax.toolbox.lang.internal.Lang");

(function() {
	
var ITEM_SLOT= "__jazzItem";

dojo.declare("com.ibm.team.workitem.web.ui.internal.view.queryeditor.PopupButton",
	[dijit._Widget, dijit._Templated], {
		
	templatePath: dojo.moduleUrl("com.ibm.team.workitem.web", "ui/internal/view/queryeditor/templates/PopupButton.html"),

	///////////////////////////////////////////////////////////////////////////////////
	// Attach points

	labelSpan: null,
	
	///////////////////////////////////////////////////////////////////////////////////
	// Private fields
	
	_menuWidget: null,
	_currentSelection: null,
	_defaultValue: null,
	
	///////////////////////////////////////////////////////////////////////////////////
	// Called on creation
	
	constructor: function(args) {
		this.labelProperty= args.labelProperty;
		this.callback= args.callback;
	},
	
	postCreate: function() {
		this._menuWidget= new dijit.Menu({});
		dojo.addClass(this._menuWidget.domNode, "customDijitMenu");
		this.connect(this._menuWidget, "onItemClick", "onSelect");		
	},
	
	destroy: function() {
		if(this._menuWidget)	this._menuWidget.destroy();
		this.inherited(arguments);
	},
	
	///////////////////////////////////////////////////////////////////////////////////
	// API
	
	setValues: function(items) {
		if (items.length > 0) {
			for (var i= 0; i < items.length; i++) {
				this._menuWidget.addChild(this._createMenuItem(items[i]));
			}
		}
	},
	
	getSelection: function() {
		return this._currentSelection;
	},
	
	setSelection: function(item) {
		this._updateSelection(item);
	},
	
	///////////////////////////////////////////////////////////////////////////////////
	// Helpers
	
	_createMenuItem: function(item) {
		var label= item[this.labelProperty];
		var menuItem= new dijit.MenuItem( { label: label });
		menuItem[ITEM_SLOT]= item;
		return menuItem;
	},
	
	_updateSelection: function(item) {
		var label= item[this.labelProperty];
		dojox.data.dom.replaceChildren(this.labelSpan, document.createTextNode(label));
		this._currentSelection= item;
	},
	
	///////////////////////////////////////////////////////////////////////////////////
	// Events
	
	onShowMenu: function(e) {
		this._menuWidget._openMyself(e);
	},
	
	onSelect: function(/* MenuItem2 */ menuItem) {
		this._updateSelection(menuItem[ITEM_SLOT]);
		if (this.callback)
			this.callback(this.getSelection());
	}
	
});

})();
