/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2007, 2008. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.workitem.web.ui.internal.view.queryeditor.SectionContainer");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dojox.data.dom");

dojo.require("com.ibm.team.workitem.web.ui.internal.view.queryeditor.PopupButton");
dojo.requireLocalization("com.ibm.team.workitem.web.ui.internal", "QueryMessages");

(function() {
	
var PopupButton= com.ibm.team.workitem.web.ui.internal.view.queryeditor.PopupButton;
var Messages= dojo.i18n.getLocalization("com.ibm.team.workitem.web.ui.internal", "QueryMessages");
	
dojo.declare("com.ibm.team.workitem.web.ui.internal.view.queryeditor.SectionContainer",
	[dijit._Widget, dijit._Templated], {

	templatePath: dojo.moduleUrl("com.ibm.team.workitem.web", "ui/internal/view/queryeditor/templates/SectionContainer.html"),
	
	///////////////////////////////////////////////////////////////////////////////////
	// API
	
	constructor: function(args) {
		this._labelProperty= "name";
		this.sectionWidget= args.sectionWidget;
		this._labelClose= Messages.labelClose;
	},
	
	postCreate: function() {
		this._bodyContainer.appendChild(this.sectionWidget.domNode);
		if (this.sectionWidget.setSectionSite)
			this.sectionWidget.setSectionSite(this);		
	},
	destroy: function() {
		if(this._menuWidget && this._menuWidget.destroy) this._menuWidget.destroy();
		if (this.sectionWidget)
			this.sectionWidget.destroy();
		this.inherited(arguments);
	},
	
	setTitle: function(title) {
		dojox.data.dom.replaceChildren(this._headerText, document.createTextNode(title));
	},
	
	setupMenu: function(property, callback) {
		this._labelProperty= property;
		this._callback= callback;
	},
	
	setMenuItems: function(menuItems, callback) {
		var menu= this._getMenu();
		menu.setValues(menuItems);
	},
	
	setSelectedMenuItem: function(item) {
		var menu= this._getMenu();
		menu.setSelection(item);
	},
	
	///////////////////////////////////////////////////////////////////////////////////
	// Internals
	
	_getMenu: function() {
		if (!this._menuWidget) {
			var menu= new PopupButton({ labelProperty: this._labelProperty, callback: this._callback });
			this._headerMenu.appendChild(menu.domNode);
			this._menuWidget= menu;
		}
		return this._menuWidget;
	},
	
	onClose: function() {
		var destroy= true;
		var sectionWidget= this.sectionWidget;
		if (sectionWidget && sectionWidget.onClose) {
			destroy= sectionWidget.onClose();
		}
		if (destroy) {
			this.destroy();
		}
	}
});

})();
